# PHP wrapper for the GRPC interfaces.

## LAYOUT

Directory structure is as generated by the PHP utility
[ext_skel](http://php.net/manual/en/internals2.buildsys.skeleton.php)

## ENVIRONMENT

To build a PHP environment that works with this extension, download and extract
PHP 5.5 (5.6 may also work), configure it, and install it:

```bash
apt-get install libxml2 libxml2-dev
curl http://php.net/get/php-5.5.16.tar.gz
tar -xf php-5.5.16.tar.gz
cd php-5.5.16
./configure --with-zlib=/usr --with-libxml-dir=ext/libxml --with-openssl=/usr/local/ssl
make
make install
```

To also download and install the patched protoc and PHP code generator:

```bash
apt-get install -y procps
curl -sSL https://get.rvm.io | sudo bash -s stable --ruby
git clone sso://team/one-platform-grpc-team/protobuf
cd protobuf
./configure
make
make install
git clone sso://team/one-platform-grpc-team/grpc-php-protobuf-php
cd grpc-php-protobuf-php
rake pear:package version=1.0
pear install Protobuf-1.0.tgz
```

## BUILDING

 1. In ./ext/grpc, run the command `phpize` (distributed with PHP)
 2. Run `./ext/grpc/configure`
 3. In ./ext/grpc, run `make` and `sudo make install`
 4. In your php.ini file, add the line `extension=grpc.so` to load the
    extension at PHP startup.

## PHPUnit

This repo now has PHPUnit tests, which can by run by executing
`./bin/run_tests.sh` after building.

There is also a generated code test (`./bin/run_gen_code_test.sh`), which tests
the stub `./tests/generated_code/math.php` against a running localhost server
serving the math service. That stub is generated from
`./tests/generated_code/math.proto` with the head of the repo
`sso://team/one-platform-grpc-team/grpc-php-protobuf-php`.
